
/////////////////////////////////////////////////////////////
//
// Source file for AudioOptionsFormUI
//
//    This class implements the user interface created in 
//    the interface builder. Normally it is not used directly.
//    Instead the subclass, AudioOptionsForm is instantiated
//
//    To extend or alter the behavior of this class, you should
//    modify the AudioOptionsForm files
//
//    Restrict changes to those sections between
//    the "//--- Start/End editable code block" markers
//
//    This will allow the builder to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//
//
/////////////////////////////////////////////////////////////


#include "AudioOptionsFormUI.h" // Generated header file for this class

#include <Sgm/Dial.h> 
#include <Xm/Form.h> 
#include <Xm/Label.h> 
#include <Xm/TextF.h> 
#include <Xm/ToggleB.h> 
#include <Vk/VkResource.h>
//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations


// These are default resources for widgets in objects of this class
// All resources will be prepended by *<name> at instantiation,
// where <name> is the name of the specific instance, as well as the
// name of the baseWidget. These are only defaults, and may be overriden
// in a resource file by providing a more specific resource name

String  AudioOptionsFormUI::_defaultAudioOptionsFormUIResources[] = {
        "*tabLabel:  Audio",
        "*label11.labelString:  Mic Gain",
        "*label10.labelString:  Volume",
        "*micOffToggle.labelString:  mic off",
        "*muteToggle.labelString:  mute",
        "*label5.labelString:  Mode:",
        "*label4.labelString:  Compression:",
        (char*)NULL
};

AudioOptionsFormUI::AudioOptionsFormUI(const char *name) : VkComponent(name) 
{ 
    // No widgets are created by this constructor.
    // If an application creates a component using this constructor,
    // It must explictly call create at a later time.
    // This is mostly useful when adding pre-widget creation
    // code to a derived class constructor.

    //---- Start editable code block: AudioOptionsForm constructor 2


    //---- End editable code block: AudioOptionsForm constructor 2


} // End Constructor




AudioOptionsFormUI::AudioOptionsFormUI(const char *name, Widget parent) : VkComponent(name) 
{ 
    // Call creation function to build the widget tree.

     create(parent);

    //---- Start editable code block: AudioOptionsForm constructor


    //---- End editable code block: AudioOptionsForm constructor


} // End Constructor


AudioOptionsFormUI::~AudioOptionsFormUI() 
{
    // Base class destroys widgets

    //---- Start editable code block: AudioOptionsFormUI destructor


    //---- End editable code block: AudioOptionsFormUI destructor
} // End destructor



void AudioOptionsFormUI::create ( Widget parent )
{
    Arg      args[13];
    Cardinal count;
    count = 0;

    // Load any class-defaulted resources for this object

    setDefaultResources(parent, _defaultAudioOptionsFormUIResources  );


    // Create an unmanaged widget as the top of the widget hierarchy

    _baseWidget = _audioOptionsForm = XtVaCreateWidget ( _name,
                                                         xmFormWidgetClass,
                                                         parent, 
                                                         XmNresizePolicy, XmRESIZE_GROW, 
                                                         (XtPointer) NULL ); 

    // install a callback to guard against unexpected widget destruction

    installDestroyHandler();


    // Create widgets used in this component
    // All variables are data members of this class

    _label11 = XtVaCreateManagedWidget  ( "label11",
                                           xmLabelWidgetClass,
                                           _baseWidget, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 90, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 155, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 65, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _label10 = XtVaCreateManagedWidget  ( "label10",
                                           xmLabelWidgetClass,
                                           _baseWidget, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 90, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 50, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 56, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _micOffToggle = XtVaCreateManagedWidget  ( "micOffToggle",
                                                xmToggleButtonWidgetClass,
                                                _baseWidget, 
                                                XmNalignment, XmALIGNMENT_BEGINNING, 
                                                XmNlabelType, XmSTRING, 
                                                XmNtopAttachment, XmATTACH_FORM, 
                                                XmNbottomAttachment, XmATTACH_NONE, 
                                                XmNleftAttachment, XmATTACH_FORM, 
                                                XmNrightAttachment, XmATTACH_NONE, 
                                                XmNtopOffset, 225, 
                                                XmNbottomOffset, 0, 
                                                XmNleftOffset, 135, 
                                                XmNrightOffset, 0, 
                                                XmNwidth, 70, 
                                                XmNheight, 30, 
                                                (XtPointer) NULL ); 


    _muteToggle = XtVaCreateManagedWidget  ( "muteToggle",
                                              xmToggleButtonWidgetClass,
                                              _baseWidget, 
                                              XmNalignment, XmALIGNMENT_BEGINNING, 
                                              XmNlabelType, XmSTRING, 
                                              XmNtopAttachment, XmATTACH_FORM, 
                                              XmNbottomAttachment, XmATTACH_NONE, 
                                              XmNleftAttachment, XmATTACH_FORM, 
                                              XmNrightAttachment, XmATTACH_NONE, 
                                              XmNtopOffset, 225, 
                                              XmNbottomOffset, 0, 
                                              XmNleftOffset, 55, 
                                              XmNrightOffset, 0, 
                                              XmNwidth, 60, 
                                              XmNheight, 30, 
                                              (XtPointer) NULL ); 


    _label5 = XtVaCreateManagedWidget  ( "label5",
                                          xmLabelWidgetClass,
                                          _baseWidget, 
                                          XmNlabelType, XmSTRING, 
                                          XmNtopAttachment, XmATTACH_FORM, 
                                          XmNbottomAttachment, XmATTACH_NONE, 
                                          XmNleftAttachment, XmATTACH_FORM, 
                                          XmNrightAttachment, XmATTACH_NONE, 
                                          XmNtopOffset, 40, 
                                          XmNbottomOffset, 0, 
                                          XmNleftOffset, 85, 
                                          XmNrightOffset, 0, 
                                          XmNwidth, 50, 
                                          XmNheight, 30, 
                                          (XtPointer) NULL ); 


    _label4 = XtVaCreateManagedWidget  ( "label4",
                                          xmLabelWidgetClass,
                                          _baseWidget, 
                                          XmNlabelType, XmSTRING, 
                                          XmNtopAttachment, XmATTACH_FORM, 
                                          XmNbottomAttachment, XmATTACH_NONE, 
                                          XmNleftAttachment, XmATTACH_FORM, 
                                          XmNrightAttachment, XmATTACH_NONE, 
                                          XmNtopOffset, 5, 
                                          XmNbottomOffset, 0, 
                                          XmNleftOffset, 30, 
                                          XmNrightOffset, 0, 
                                          XmNwidth, 102, 
                                          XmNheight, 20, 
                                          (XtPointer) NULL ); 


    _micDial = XtVaCreateManagedWidget  ( "micDial",
                                           sgDialWidgetClass,
                                           _baseWidget, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 115, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 140, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 100, 
                                           XmNheight, 100, 
                                           (XtPointer) NULL ); 


    _volumeDial = XtVaCreateManagedWidget  ( "volumeDial",
                                              sgDialWidgetClass,
                                              _baseWidget, 
                                              XmNtopAttachment, XmATTACH_FORM, 
                                              XmNbottomAttachment, XmATTACH_NONE, 
                                              XmNleftAttachment, XmATTACH_FORM, 
                                              XmNrightAttachment, XmATTACH_NONE, 
                                              XmNtopOffset, 115, 
                                              XmNbottomOffset, 0, 
                                              XmNleftOffset, 30, 
                                              XmNrightOffset, 0, 
                                              XmNwidth, 100, 
                                              XmNheight, 100, 
                                              (XtPointer) NULL ); 


    _audioModeText = XtVaCreateManagedWidget  ( "audioModeText",
                                                 xmTextFieldWidgetClass,
                                                 _baseWidget, 
                                                 XmNeditable, False, 
                                                 XmNtopAttachment, XmATTACH_FORM, 
                                                 XmNbottomAttachment, XmATTACH_NONE, 
                                                 XmNleftAttachment, XmATTACH_FORM, 
                                                 XmNrightAttachment, XmATTACH_NONE, 
                                                 XmNtopOffset, 40, 
                                                 XmNbottomOffset, 0, 
                                                 XmNleftOffset, 135, 
                                                 XmNrightOffset, 0, 
                                                 XmNwidth, 105, 
                                                 XmNheight, 30, 
                                                 (XtPointer) NULL ); 
    XtVaSetValues ( _audioModeText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _audioModeText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _audioCompressionText = XtVaCreateManagedWidget  ( "audioCompressionText",
                                                        xmTextFieldWidgetClass,
                                                        _baseWidget, 
                                                        XmNeditable, False, 
                                                        XmNtopAttachment, XmATTACH_FORM, 
                                                        XmNbottomAttachment, XmATTACH_NONE, 
                                                        XmNleftAttachment, XmATTACH_FORM, 
                                                        XmNrightAttachment, XmATTACH_NONE, 
                                                        XmNtopOffset, 5, 
                                                        XmNbottomOffset, 0, 
                                                        XmNleftOffset, 135, 
                                                        XmNrightOffset, 0, 
                                                        XmNwidth, 105, 
                                                        XmNheight, 30, 
                                                        (XtPointer) NULL ); 
    XtVaSetValues ( _audioCompressionText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _audioCompressionText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    //---- Start editable code block: AudioOptionsFormUI create


    //---- End editable code block: AudioOptionsFormUI create
}

const char * AudioOptionsFormUI::className()
{
    return ("AudioOptionsFormUI");
} // End className()




/////////////////////////////////////////////////////////////// 
// The following functions are called from the menu items 
// in this window.
/////////////////////////////////// 



